/**********************************************************/
/*    Projekt:                                            */
/**********************************************************/
/*    Autor:        Robert Siegler                        */
/*    Compiler:     IAR EWAVR 2.28A / UI 2.31E            */
/*    Prfer:       -                                     */
/*    Quelldatei:   define.h                              */
/*    Stand:                                              */
/*    Version:                                            */
/**********************************************************/
/*    Restriktionen:                                      */
/**********************************************************/
/*    -Definitionen jeglicher Art in Quelldateien (*.c)   */
/*     platzieren! Header-Dateien dienen ausschlielich   */
/*     der Deklaration von Programm-Elementen!            */
/**********************************************************/
/*    Aenderung:                                          */
/**********************************************************/
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/**********************************************************/

/*******************/
/* if-Definitionen */
/*******************/

#ifndef define_h_
#define define_h_

/***********************************/
/* Enable use of extended keywords */
/***********************************/

#pragma language = extended

/***************************************/
/* Einbindung bentigter Headerdateien */
/***************************************/

#include <ina90.h>
#include <iom128.h>

/**********************/
/* Defines fr Init() */
/**********************/

// Port E: (RS232-Schnittstellen- und Tastaturport, Pull-Up-Enable, Bit 0 und 1 Tristate)
// E: Bit 0, 1, 2, 3, 4, 5, 6, 7
#define SETZEPORT_E       PORTE = 0xFC; DDRE = 0x00;

/********************/
/* Defines fr Menu */
/********************/

#define In_Taste_Escape (tastencode & TASTE_ESCAPE)
#define In_Taste_Enter  (tastencode & TASTE_ENTER)
#define In_Taste_Left   (tastencode & TASTE_LEFT)
#define In_Taste_Right  (tastencode & TASTE_RIGHT)
#define In_Taste_Down   (tastencode & TASTE_DOWN)
#define In_Taste_Up     (tastencode & TASTE_UP)

/*******************************************************/
/* Defines der Wertzuweisungen fr die Variable Merker */
/*******************************************************/

// SET-Variablen, d.h. Variablen, die ein Bit "setzen"
#define set_Menue       Merker.Menue = 1
#define set_Escape      Merker.Escape = 1
#define set_Enter       Merker.Enter = 1
#define set_Left        Merker.Left = 1
#define set_Right       Merker.Right = 1
#define set_Down        Merker.Down = 1
#define set_Up          Merker.Up = 1

// RESET-Variablen, d.h. Variablen, die ein Bit "lschen"
#define reset_Menue     Merker.Menue = 0
#define reset_Escape    Merker.Escape = 0
#define reset_Enter     Merker.Enter = 0
#define reset_Left      Merker.Left = 0
#define reset_Right     Merker.Right = 0
#define reset_Down      Merker.Down = 0
#define reset_Up        Merker.Up = 0

/**********************************************************/
/* Deklaration der Struktur fr die Bit-Variable "Merker" */
/**********************************************************/

struct Taste
{
  char Menue : 1;
  char Escape : 1;
  char Enter : 1;
  char Left : 1;
  char Right : 1;
  char Down : 1;
  char Up : 1;
};

/***********************/
/* Defines fr Taste() */
/***********************/

#define TASTE_UP        0x80 // Hex-Wert Up-Taste an Port E
#define TASTE_DOWN      0x40 // Hex-Wert Left-Taste an Port E
#define TASTE_RIGHT     0x20 // Hex-Wert Right-Taste an Port E
#define TASTE_LEFT      0x10 // Hex-Wert Down-Taste an Port E
#define TASTE_ENTER     0x08 // Hex-Wert Enter-Taste an Port E
#define TASTE_ESCAPE    0x04 // Hex-Wert Escape-Taste an Port E

// Ende der if-Definition von _define_h_
#endif
