/**********************************************************/
/*    Projekt:                                            */
/**********************************************************/
/*    Autor:        Robert Siegler                        */
/*    Compiler:     IAR EWAVR 2.28A / UI 2.31E            */
/*    Prfer:       -                                     */
/*    Quelldatei:   init.c                                */
/*    Stand:                                              */
/*    Version:                                            */
/**********************************************************/
/*    Restriktionen:                                      */
/**********************************************************/
/*    -Keine bekannten                                    */
/*                                                        */
/**********************************************************/
/*    Aenderungen:                                        */
/**********************************************************/
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/**********************************************************/

/*********************************/
/* Enable use of bit definitions */
/*********************************/

#define ENABLE_BIT_DEFINITIONS

/***********************************/
/* Enable use of extended keywords */
/***********************************/

#pragma language = extended

/***************************************/
/* Einbindung bentigter Headerdateien */
/***************************************/

#include "define.h"
#include "init.h"

// Globale Variablendefinitionen

// Deklarationen extern definierter Variablen

// Strukturdefinitionen

// Externe Strukturdeklarationen

/*******************/
/* Zeichentabellen */
/*******************/

/******************************************/
/* Deklarationen externer Zeichentabellen */
/******************************************/

/********************************************************************************/
/* Die Funktion Init() initialisiert nach dem Power-On die bentigte Periperie. */
/********************************************************************************/

void Init(void)
{
  /**************************************************************/
  /* Port A, B, C, D, E, F und G konfigurieren (siehe define.h) */
  /**************************************************************/

  SETZEPORT_A; //

  SETZEPORT_B; //

  SETZEPORT_C; //

  SETZEPORT_D; //

  SETZEPORT_E; // RS232-Schnittstellen- und Tastaturport

  SETZEPORT_F; // JTAG-Port, bitte nicht verwenden!

  SETZEPORT_G; //

  /**********************************************************/
  /* Startsignal- und Tastatur-Timer 2 initialisieren       */
  /* Controller: ATmega128 mit 4 MHz Quarz, tcycle = 250 ns */
  /* OCR-Interrupt alle 5,12 ms                             */
  /**********************************************************/

  TCCR2 |= 0x0D; // Prescaler = 1024, Normal Port Operation, OCF

  OCR2 = 0x13; // Timer-Reloadwert = 19 + 1 = 20 fr 5,12 ms Abtastrate

  TIMSK |= 0x80; // Timer/Counter2 Output Compare Match Interrupt Enable
} // Init()
