/**********************************************************/
/*    Projekt:                                            */
/**********************************************************/
/*    Autor:        Robert Siegler                        */
/*    Prfer:       -                                     */
/*    Quelldatei:   taste.c                               */
/*    Stand:                                              */
/*    Version:                                            */
/**********************************************************/
/*    Restriktionen:                                      */
/**********************************************************/
/*    -Keine bekannten                                    */
/*                                                        */
/**********************************************************/
/*    Aenderungen:                                        */
/**********************************************************/
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/**********************************************************/

/***********************************/
/* Enable use of extended keywords */
/***********************************/

#pragma language = extended

/***************************************/
/* Einbindung bentigter Headerdateien */
/***************************************/

#include "define.h"
#include "taste.h"

// Globale Variablendefinitionen

char PORT_LATCH[4], prellzaehler0, tastencode; // Speicherarray fr Portzustnde und Variablen

// Deklarationen extern definierter  Variablen

// Strukturdefinitionen

// Externe Strukturdeklarationen

extern struct Taste Merker;

/*******************/
/* Zeichentabellen */
/*******************/

/******************************************/
/* Deklarationen externer Zeichentabellen */
/******************************************/

/*************************************************************************************************/
/* PORTE einlesen. Abtasten des Eingangswertes in einem bestimmten Zeitraster. Zwischenspeichern */
/* der zuletzt abgetasteten Werte. Akzeptieren eines Wertes nur, wenn alle abgetasteten (und ge- */
/* speicherten) Werte gleich sind. Die Funktion PortEin() dient der Tastaturentprellung und      */
/* wird alle 5,12 ms ber den Interrupt aufgerufen. Eine Taste wird als gedrckt erkannt, wenn   */
/* diese mindestens 20,48 ms gedrckt worden ist.                                                */
/*************************************************************************************************/

void PortEin(void)
{
  char i; // Schleifenvariable

  char port_latch_and; // Verundungsvariable

  char port_latch_or; // Veroderungsvariable

  prellzaehler0 = (prellzaehler0 + 1) % 4; // Prellzhler zhlt 1-2-3-0-1-2-3-0-1-2-3 etc.

  PORT_LATCH[prellzaehler0] = ~PINE; // Aktuellen Zustand an PORTE einlesen

  port_latch_and = PORT_LATCH[0]; // 0. Arrayelement in port_latch_and2 kopieren

  port_latch_or = PORT_LATCH[0]; // 0. Arrayelement in port_latch_or2 kopieren

  for(i = 1; i < 4; i++)
  {
    port_latch_and &= PORT_LATCH[i]; // Nur 4 laufende Einsen ergeben logisch 1

    port_latch_or |= PORT_LATCH[i]; // Nur 4 laufende Nullen ergeben logisch 0
  }

  /****************************/
  /* PORTE auswerten          */
  /****************************/

  tastencode |= port_latch_and; // Suche nach 0-1-Flanken

  tastencode &= port_latch_or; // Suche nach 1-0-Flanken
} // PortEin()

/******************************************************************************************/
/* Taste() berprft, welche der Tasten gedrckt wurde und setzt den betreffenden Merker. */
/******************************************************************************************/

void Taste(void)
{
  tastencode &= 0xFC;  // Bit 0 und 1 ausmaskieren, da nicht belegt

  switch(tastencode)   // Variable "tastencode" von PORTC vergleichen
  {
    case TASTE_ESCAPE: // Wenn ESCAPE-Taste gedrckt
      set_Escape;      // Escape-Merker setzen
    break;

    case TASTE_ENTER:  // Wenn ENTER-Taste gedrckt
      set_Enter;       // Enter-Merker setzen
    break;

    case TASTE_LEFT:   // Wenn LEFT-Taste gedrckt
      set_Left;        // Left-Merker setzen
     break;

    case TASTE_RIGHT:  // Wenn RIGHT-Taste gedrckt
      set_Right;       // Right-Merker setzen
     break;

    case TASTE_DOWN:   // Wenn DOWN-Taste gedrckt
      set_Down;        // Down-Merker setzen
    break;

    case TASTE_UP:     // Wenn UP-Taste gedrckt
      set_Up;          // Up-Merker setzen
    break;
  } // switch()
} // Taste()
